perf stat: Introduce --control fd:ctl-fd[,ack-fd] options
authorAlexey Budankov <alexey.budankov@linux.intel.com>
Fri, 17 Jul 2020 07:05:41 +0000 (10:05 +0300)
committerArnaldo Carvalho de Melo <acme@redhat.com>
Tue, 4 Aug 2020 11:48:58 +0000 (08:48 -0300)
Introduce --control fd:ctl-fd[,ack-fd] options to pass open file
descriptors numbers from command line. Extend perf-stat.txt file with
--control fd:ctl-fd[,ack-fd] options description. Document possible
usage model introduced by --control fd:ctl-fd[,ack-fd] options by
providing example bash shell script.

Signed-off-by: Alexey Budankov <alexey.budankov@linux.intel.com>
Acked-by: Jiri Olsa <jolsa@redhat.com>
Acked-by: Namhyung Kim <namhyung@kernel.org>
Cc: Alexander Shishkin <alexander.shishkin@linux.intel.com>
Cc: Andi Kleen <ak@linux.intel.com>
Cc: Peter Zijlstra <peterz@infradead.org>
Link: http://lore.kernel.org/lkml/feabd5cf-0155-fb0a-4587-c71571f2d517@linux.intel.com
Signed-off-by: Arnaldo Carvalho de Melo <acme@redhat.com>
tools/perf/Documentation/perf-stat.txt
tools/perf/builtin-stat.c
tools/perf/util/stat.h

index 9f32f6c..c9bfefc 100644 (file)
@@ -176,6 +176,45 @@ with it.  --append may be used here.  Examples:
      3>results  perf stat --log-fd 3          -- $cmd
      3>>results perf stat --log-fd 3 --append -- $cmd
 
+--control fd:ctl-fd[,ack-fd]
+Listen on ctl-fd descriptor for command to control measurement ('enable': enable events,
+'disable': disable events). Measurements can be started with events disabled using
+--delay=-1 option. Optionally send control command completion ('ack\n') to ack-fd descriptor
+to synchronize with the controlling process. Example of bash shell script to enable and
+disable events during measurements:
+
+#!/bin/bash
+
+ctl_dir=/tmp/
+
+ctl_fifo=${ctl_dir}perf_ctl.fifo
+test -p ${ctl_fifo} && unlink ${ctl_fifo}
+mkfifo ${ctl_fifo}
+exec {ctl_fd}<>${ctl_fifo}
+
+ctl_ack_fifo=${ctl_dir}perf_ctl_ack.fifo
+test -p ${ctl_ack_fifo} && unlink ${ctl_ack_fifo}
+mkfifo ${ctl_ack_fifo}
+exec {ctl_fd_ack}<>${ctl_ack_fifo}
+
+perf stat -D -1 -e cpu-cycles -a -I 1000       \
+          --control fd:${ctl_fd},${ctl_fd_ack} \
+          -- sleep 30 &
+perf_pid=$!
+
+sleep 5  && echo 'enable' >&${ctl_fd} && read -u ${ctl_fd_ack} e1 && echo "enabled(${e1})"
+sleep 10 && echo 'disable' >&${ctl_fd} && read -u ${ctl_fd_ack} d1 && echo "disabled(${d1})"
+
+exec {ctl_fd_ack}>&-
+unlink ${ctl_ack_fifo}
+
+exec {ctl_fd}>&-
+unlink ${ctl_fifo}
+
+wait -n ${perf_pid}
+exit $?
+
+
 --pre::
 --post::
        Pre and post measurement hooks, e.g.:
index 5280a45..483a28e 100644 (file)
@@ -188,6 +188,8 @@ static struct perf_stat_config stat_config = {
        .metric_only_len        = METRIC_ONLY_LEN,
        .walltime_nsecs_stats   = &walltime_nsecs_stats,
        .big_num                = true,
+       .ctl_fd                 = -1,
+       .ctl_fd_ack             = -1
 };
 
 static bool cpus_map_matched(struct evsel *a, struct evsel *b)
@@ -867,7 +869,7 @@ try_again_reset:
                perf_evlist__start_workload(evsel_list);
                enable_counters();
 
-               if (interval || timeout)
+               if (interval || timeout || evlist__ctlfd_initialized(evsel_list))
                        status = dispatch_events(forks, timeout, interval, &times);
                if (child_pid != -1) {
                        if (timeout)
@@ -1039,6 +1041,33 @@ static int parse_metric_groups(const struct option *opt,
                                         &stat_config.metric_events);
 }
 
+static int parse_control_option(const struct option *opt,
+                               const char *str,
+                               int unset __maybe_unused)
+{
+       char *comma = NULL, *endptr = NULL;
+       struct perf_stat_config *config = (struct perf_stat_config *)opt->value;
+
+       if (strncmp(str, "fd:", 3))
+               return -EINVAL;
+
+       config->ctl_fd = strtoul(&str[3], &endptr, 0);
+       if (endptr == &str[3])
+               return -EINVAL;
+
+       comma = strchr(str, ',');
+       if (comma) {
+               if (endptr != comma)
+                       return -EINVAL;
+
+               config->ctl_fd_ack = strtoul(comma + 1, &endptr, 0);
+               if (endptr == comma + 1 || *endptr != '\0')
+                       return -EINVAL;
+       }
+
+       return 0;
+}
+
 static struct option stat_options[] = {
        OPT_BOOLEAN('T', "transaction", &transaction_run,
                    "hardware transaction statistics"),
@@ -1140,6 +1169,10 @@ static struct option stat_options[] = {
                "libpfm4 event selector. use 'perf list' to list available events",
                parse_libpfm_events_option),
 #endif
+       OPT_CALLBACK(0, "control", &stat_config, "fd:ctl-fd[,ack-fd]",
+                    "Listen on ctl-fd descriptor for command to control measurement ('enable': enable events, 'disable': disable events).\n"
+                    "\t\t\t  Optionally send control command completion ('ack\\n') to ack-fd descriptor.",
+                     parse_control_option),
        OPT_END()
 };
 
@@ -2309,6 +2342,9 @@ int cmd_stat(int argc, const char **argv)
        signal(SIGALRM, skip_signal);
        signal(SIGABRT, skip_signal);
 
+       if (evlist__initialize_ctlfd(evsel_list, stat_config.ctl_fd, stat_config.ctl_fd_ack))
+               goto out;
+
        status = 0;
        for (run_idx = 0; forever || run_idx < stat_config.run_count; run_idx++) {
                if (stat_config.run_count != 1 && verbose > 0)
@@ -2328,6 +2364,8 @@ int cmd_stat(int argc, const char **argv)
        if (!forever && status != -1 && (!interval || stat_config.summary))
                print_counters(NULL, argc, argv);
 
+       evlist__finalize_ctlfd(evsel_list);
+
        if (STAT_RECORD) {
                /*
                 * We synthesize the kernel mmap record just so that older tools
index 41d59f1..f8778cf 100644 (file)
@@ -133,6 +133,8 @@ struct perf_stat_config {
        struct perf_cpu_map             *cpus_aggr_map;
        u64                     *walltime_run;
        struct rblist            metric_events;
+       int                      ctl_fd;
+       int                      ctl_fd_ack;
 };
 
 void perf_stat__set_big_num(int set);